--- lrb_prototype_primitives.inl	2010-06-15 17:01:51.147217886 +0200
+++ lrbni_prototypes.h	2010-06-15 17:01:22.767217213 +0200
@@ -2857,9 +2881,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = p2[i] & p3[i];
@@ -2882,10 +2906,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -2925,10 +2949,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *p2 = (int64_t *) &v2;
-    int64_t *p3 = (int64_t *) &v3;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
+    _LPP_Int64 *p3 = (_LPP_Int64 *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -2961,9 +2985,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         unsigned int bit = 1;
@@ -2982,10 +3006,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
        if (k1 & 1) {
@@ -3009,9 +3033,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         unsigned int bit = 1;
@@ -3034,10 +3058,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
        if (k1 & 1) {
@@ -3066,9 +3090,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (p3[i] < p2[i]) r[i] = p3[i];
@@ -3099,10 +3123,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -3144,9 +3168,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (p3[i] >= 0) {
@@ -3181,10 +3205,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -3230,8 +3254,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int byteMask = _LPP_byteMaskTable[field];
 
     for (int i=0; i < 16; i++) {
@@ -3261,8 +3285,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int byteMask = _LPP_byteMaskTable[field];
 
     for (int i=0; i < 16; i++) {
@@ -3282,8 +3306,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int byteMask = _LPP_byteMaskTable[field];
 
     for (int i=0; i < 16; i++) {
@@ -3304,8 +3328,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int byteMask = _LPP_byteMaskTable[field];
 
     for (int i=0; i < 16; i++) {
@@ -3336,8 +3360,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int byteMask = _LPP_byteMaskTable[field];
 
     for (int i=0; i < 16; i++) {
@@ -3357,8 +3381,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
     unsigned int byteMask = _LPP_byteMaskTable[field];
 
     for (int i=0; i < 16; i++) {
@@ -3379,8 +3403,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (p1[i] == p2[i]) result |= (1 << i);
@@ -3408,8 +3432,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (p1[i] < p2[i]) result |= (1 << i);
@@ -3437,8 +3461,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (p1[i] <= p2[i]) result |= (1 << i);
@@ -3466,8 +3490,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (!(p1[i] <= p2[i] || p1[i] > p2[i])) result |= (1 << i);
@@ -3495,8 +3519,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (p1[i] != p2[i]) result |= (1 << i);
@@ -3524,8 +3548,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (!(p1[i] < p2[i])) result |= (1 << i);
@@ -3553,8 +3577,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (!(p1[i] <= p2[i])) result |= (1 << i);
@@ -3582,8 +3606,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (p1[i] <= p2[i] || p1[i] > p2[i]) result |= (1 << i);
@@ -3611,8 +3635,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] == p2[i]) result |= (1 << i);
@@ -3641,8 +3665,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] < p2[i]) result |= (1 << i);
@@ -3671,8 +3695,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] <= p2[i]) result |= (1 << i);
@@ -3702,8 +3726,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] != p2[i]) result |= (1 << i);
@@ -3733,8 +3757,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (!(p1[i] < p2[i])) result |= (1 << i);
@@ -3764,8 +3788,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] > p2[i]) result |= (1 << i);
@@ -3794,8 +3818,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] == p2[i]) result |= (1 << i);
@@ -3823,8 +3847,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] < p2[i]) result |= (1 << i);
@@ -3852,8 +3876,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] <= p2[i]) result |= (1 << i);
@@ -3881,8 +3905,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (!(p1[i] <= p2[i] || p1[i] > p2[i])) result |= (1 << i);
@@ -3910,8 +3934,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] != p2[i]) result |= (1 << i);
@@ -3939,8 +3963,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (!(p1[i] < p2[i])) result |= (1 << i);
@@ -3968,8 +3992,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (!(p1[i] <= p2[i])) result |= (1 << i);
@@ -3997,8 +4021,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] <= p2[i] || p1[i] > p2[i]) result |= (1 << i);
@@ -4026,8 +4050,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] == p2[i]) result |= (1 << i);
@@ -4055,8 +4079,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] < p2[i]) result |= (1 << i);
@@ -4075,8 +4099,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] <= p2[i]) result |= (1 << i);
@@ -4096,8 +4120,8 @@
     __mmask result = 0;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] != p2[i]) result |= (1 << i);
@@ -4126,8 +4150,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (!(p1[i] < p2[i])) result |= (1 << i);
@@ -4146,8 +4170,8 @@
 {
     __mmask result = 0;
 
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (p1[i] > p2[i]) result |= (1 << i);
@@ -4168,9 +4192,9 @@
 
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (field == _MM_FLOAT11A) {
@@ -4193,9 +4217,9 @@
 
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -4221,9 +4245,9 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (field == _MM_UNORM10A) {
@@ -4244,9 +4268,9 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -4273,9 +4297,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertFloat64ToInt32(p2[i], rc);
@@ -4304,9 +4328,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4345,9 +4369,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[8 + i] = _LPP_ConvertFloat64ToInt32(p2[i], rc);
@@ -4376,9 +4400,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4417,9 +4441,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertFloat64ToFloat32(p2[i], rc);
@@ -4448,9 +4472,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4489,9 +4513,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[8 + i] = _LPP_ConvertFloat64ToFloat32(p2[i], rc);
@@ -4520,9 +4544,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4560,9 +4584,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertFloat64ToUInt32(p2[i], rc);
@@ -4576,9 +4600,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4597,9 +4621,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[8 + i] = _LPP_ConvertFloat64ToUInt32(p2[i], rc);
@@ -4613,9 +4637,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    double *p2 = (double *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4635,8 +4659,8 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    int *p2 = (int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertInt32ToFloat64(p2[i]);
@@ -4660,9 +4684,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    int *p2 = (int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4697,8 +4721,8 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    int *p2 = (int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertInt32ToFloat64(p2[8 + i]);
@@ -4722,9 +4746,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    int *p2 = (int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4759,8 +4783,8 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    int *p2 = (int *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_ConvertInt32ToFloat32(p2[i], expadj);
@@ -4788,9 +4812,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    int *p2 = (int *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -4829,8 +4853,8 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertFloat32ToFloat64(p2[i]);
@@ -4853,9 +4877,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4889,8 +4913,8 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertFloat32ToFloat64(p2[8 + i]);
@@ -4913,9 +4937,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -4949,8 +4973,8 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_ConvertFloat32ToInt32(p2[i], rc, expadj);
@@ -4981,9 +5005,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5024,8 +5048,8 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_ConvertFloat32ToUInt32(p2[i], rc, expadj);
@@ -5038,9 +5062,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5058,8 +5082,8 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = (int) _LPP_ConvertFloat32ToSRgb8(p2[i]);
@@ -5072,9 +5096,9 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5092,8 +5116,8 @@
 {
     _M512D result;
 
-    double *r = (double *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertUInt32ToFloat64(p2[i]);
@@ -5106,9 +5130,9 @@
 {
     _M512D result;
 
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -5126,8 +5150,8 @@
 {
     _M512D result;
 
-    double *r = (double *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_ConvertUInt32ToFloat64(p2[8 + i]);
@@ -5140,9 +5164,9 @@
 {
     _M512D result;
 
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -5160,8 +5184,8 @@
 {
     _M512 result;
 
-    float *r = (float *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_ConvertUInt32ToFloat32(p2[i], expadj);
@@ -5174,9 +5198,9 @@
 {
     _M512 result;
 
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5193,19 +5217,19 @@
 inline _M512 _mm512_mask_fixup_ps(_M512 v1, __mmask k1, _M512 v2, _MM_FIXUPTABLE_ENUM table)
 {
     _M512 result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         int type;
 
         if (k1 & 1) {
-            if (_LPP_isINF(*(float *) &p2[i]) && (p2[i] & 0x80000000)) type = 0;
+            if (_LPP_isINF(*(_LPP_Float *) &p2[i]) && (p2[i] & 0x80000000)) type = 0;
             else if (p2[i] == 0x80000000)                              type = 2;
             else if (p2[i] == 0)                                       type = 3;
-            else if (_LPP_isINF(*(float *) &p2[i]))                    type = 5;
-            else if (_LPP_isNaN(*(float *) &p2[i]))                    type = 6;
+            else if (_LPP_isINF(*(_LPP_Float *) &p2[i]))                    type = 5;
+            else if (_LPP_isNaN(*(_LPP_Float *) &p2[i]))                    type = 6;
             else if (p2[i] & 0x80000000)                               type = 1;
             else                                                       type = 4;
 
@@ -5255,10 +5279,10 @@
 {
     _M512 result;
     
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *idx = (int *) &index;
-    char *src = (char *) m;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *idx = (_LPP_Int *) &index;
+    _LPP_Char *src = (_LPP_Char *) m;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5277,9 +5301,9 @@
 {
     _M512 result;
     
-    int *r = (int *) &result;
-    int *idx = (int *) &index;
-    char *src = (char *) m;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *idx = (_LPP_Int *) &index;
+    _LPP_Char *src = (_LPP_Char *) m;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_FullUpConv((void *) (src + idx[i]*scale), up_conv);
@@ -5303,8 +5327,8 @@
 {
     _M512 result;
 
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
     int exponent;
 
     for (int i=0; i < 16; i++) {
@@ -5319,9 +5343,9 @@
 {
     _M512 result;
 
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
     int exponent;
 
     for (int i=0; i < 16; i++) {
@@ -5340,9 +5364,9 @@
 inline _M512I _mm512_insertfield_pi(_M512I v2, _M512I v3, _MM_BITPOSITION32_ENUM rotation, _MM_BITPOSITION32_ENUM bit_idx_low, _MM_BITPOSITION32_ENUM bit_idx_high)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
     unsigned int maskRight = 0xFFFFFFFF >> (31 - bit_idx_high);
     unsigned int maskLeft = 0xFFFFFFFF << bit_idx_low;
     unsigned int mask;
